	TITLE Rom Upload 1.1
**miscdoc+**************************************************
*
*    File: uplrom.s via IR
* Machine: Charlemagne, Alcuin
* Created: July/23/1998 , J-Y Avenard
* Modified: April/1/1999, J-Y Avenard: Use the IR port instead
* Purpose: Upload the ROM of the HP48
*
**+miscdoc**************************************************

INCLUDE hpentr.a

ASSEMBLE

EOT	EQU	4
ACK	EQU	6
CAN	EQU	#18
NAK	EQU	#15

sError		EQU	1
sOnKeyDown	EQU	2
s1stpart	EQU	3
sReceive	EQU	4
sXRecAbort	EQU	5
sPktError	EQU	6
sAlcuin		EQU	7

* Uncomment the speed rate you want.

*IOSPEED		EQU	0	For 1200bps rate
IOSPEED		EQU	2	For 2400bps rate
*IOSPEED		EQU	4	For 4800bps rate		
*IOSPEED		EQU	6	For 9600bps rate

	NIBASC /HPHP48-X/

RPL

  ::
   CK0
   TOADISP
   CLEARLCD
   GARBAGE
   $ "Uploading ROM with IR."
   DISPROW4		
   THIRTYTHREE SetSysFlag	( Assert IR I/O )
   DOOPENIO 			( Open the Serial Port:	IR )
CODE
*
* Algorithm:
*	Wait up to 1 minute for a NAK or CAN
*	If CAN or timeout, exit with carry set
*	Send data packets
*	  If CAN received instead of ACK or NAK, exit with carry set
*	  Wait 15 seconds, then retransmit packet if no response
*	Send EOT, retransmitting if NAKd, exiting if ACKd
*
* Packet format:
*	SOH pkt# ~pkt# <128 bytes data> checksum
* where packet numbers start with 1
*

	CLRST			Clear sReceive
	ST=1	sError
	GOSBVL	=SAVPTR
	AD0EX
	D1=A			D1=AVMEM
	A=A+A	A		Carry if Alcuin
	LC(5)	#70000		For charles (256K-32K)
	GONC	Charles1
	ST=1	sAlcuin
	LC(5)	#80000		For alcuin (256K)
Charles1
	CSRB.F	A		C[A]: size of object in bytes
	R1=C			R1[A]: size of object in bytes
	LCHEX	901		
	R2=C			R2[B]: expected pkt #, R2[XS]: retry counter

*
* We copy the main program into the main RAM
*
	LC(5)	(EndOfCode)-(BeginOfCode)	Size of the main program
	R4=C
	GOSBVL	=MAKE$N		Create the string
	CD0EX
	RSTK=C			Save the @ of the new program
	D1=C			Target address
	A=PC
	LC(5)	(BeginOfCode)-(*)	@Main program
	A=A+C	A
	D0=A			Source address
	C=R4			Copy the program into the Temporary
	GOSBVL	=MOVEDOWN	Object Area (TOA)
	AD1EX			End address of the new program
	LC(5)	#80000
	?ST=0	sAlcuin
	GOYES	Charles.1
	LC(5)	#C0000
Charles.1
	?A<C	A		If the program is still located
	GOYES	OkMainProgram	on two modules
	GOSBVL	=GETPTR		then
	GOSBVL	#04FBB		Insufficient Memory
OkMainProgram
	RTN			Let's goooo !
	
BeginOfCode
	GOSBVL	=DisableIntr
	A=0	A		Rom based address
	R0=A			R0[A] -> begin address

*
* Remove BankSwitcher, and DockAddr if on Alcuin (the ROM is covered only by
* the internal RAM on charles. Now we will have access to the covered ROM
*
	?ST=0	sAlcuin
	GOYES	Charles2
	D0=(5)	#7F000		BEN=0 (disable banks)
	A=DAT0	B
	D0=(5)	#8069A		D0=(5)LINECOUNTg
	A=DAT0	B
	ABIT=1	7		DA19=1, enable ROM
	D0=(5)	=LINECOUNT
	DAT0=A	B

	D0=(5)	#8052F		D0=(5)(=CONFTAB)+#4
	A=DAT0	B
	?A#0	P		Test if a card is present in slot1
	GOYES	CardInPort1
	LC(5)	#7E000		No, unconfig the DOCK
	GONC	Port1Next	B.E.T
CardInPort1
	LC(5)	#C0000		Yes, unconfig the card
Port1Next
	UNCNFG			Dock1 (eg Port1)

	D0=(5)	#80531		D0=(5)(=CONFTAB)+#6
	A=DAT0	B
	?A#0	P		Same with port2
	GOYES	CardInPort2
	LC(5)	#7E000
	GONC	Port2Next	B.E.T
CardInPort2
	LC(5)	#C0000
Port2Next
	UNCNFG			Dock2 (eg Port2)

	LC(5)	#7F000		BankSwitcher
	UNCNFG
Charles2

	D0=(5)	#0010D		Insure to be at

	LC(1)	IOSPEED		wanted speed
	DAT0=C	1

*
* Start Xmodem protocol
*
XSend10	LC(5)	8192*30		30 second timeout for NAK or CAN
	GOSUB	RecByte		CS: timeout, CC: A[A] = byte
XSExj1	GOC	XSendExitCj
	LC(2)	CAN		
	?A=C	B		CAN?
	GOYES	XSendExitj	Yes, exit
	LC(2)	NAK
	?A#C	B		Garbage byte?
	GOYES	XSend10		Yes
*
* R2[B]: packet number
* R2[XS]: retry count
* R1[A]: #bytes of data left to send in object
* R0[A] -> data to send
*

XSend20 A=R0
	D0=A			D0 -> data to send
	GOSUB	SendPktHdr	Send SOH, pkt #, complemented pkt #
	B=0	A		Clear checksum 
	C=0	A
	LC(2)	128

XSend22	A=R1			A[A]: # bytes of data left
	A=A-C	A
	GONC	XSend24		Enough to fill packet
	C=C+A	A		C[A]: # bytes of data left
	A=-A	A		A[B]: padding needed
	ASL	A
	ASL	A
	C=A+C	A
XSend24	R3=C			R3[B]: # data bytes
	C=C-1	B		Use count of "n-1"
	D=C	A		D[B]: # data bytes - 1, D[3:2]: # pad bytes
XSend25	C=DAT0	B		Read a byte
	D0=D0+	2
	B=B+C	A		Compute checksum in B[B]
	GOSUB	SendByte
	D=D-1	B		Sent all data bytes?
	GONC	XSend25		No, keep going
	DSR	A
	DSR	A		Padding may be needed
	GOC	Pad20		BET

ReSendP	C=R2
	C=C-1	XS		Retried out?
	R2=C
	GOC	XSExitj		Yes, quit
	?ST=1	sOnKeyDown
	GOYES	XSendCAN	Detected ON key, send CANs and exit
	GOTO	XSend20

XSendExitj
	LCHEX	00A03		Interrupted
XSendExitCj
	ST=1	sError
	GOTO	XSendExitC

XSExitj	GOTO	XSendExit

Pad10	C=0	A
	GOSUB	SendByte
Pad20	D=D-1	B
	GONC	Pad10
	C=B	A		C[B]: arithmetic checksum
	GOSUB	SendByteTIO
	?ST=1	sOnKeyDown
	GOYES	XSendCAN

*
* Now look for  ACK, NAK, or CAN byte
*
	GOSUB	RecByte15	CS: 5 sec timeout, CC: A[A] = byte
ReSendPj
	GOC	ReSendP		Timed out, resend the packet
	LC(2)	CAN
	?A=C	B		CAN?
	GOYES	XSExitj		Yes, exit
	LC(2)	ACK
	?A#C	B		NAK or garbage byte?
	GOYES	ReSendPj	Yes, resend the packet
*
* Got an ACK, prepare to send next packet
*
	AD0EX			
	R0=A			R0[A] -> start of data for next packet
	D0=A
	C=R2
	C=C+1	A		Increment packet number
	P=	2
	LC(1)	9		Reset retry counter
	P=	0
	R2=C
	A=R1			A[A]: # bytes left in obj before this pkt
	C=R3			C[B]: #bytes sent
	B=0	A
	B=C	B		B[A]: # bytes sent in this packet
	A=A-B	A
	R1=A
	?A=0	A		Finished sending object?
	GOYES	XSend80		Yes
	GOTO	XSend20		No, send next packet
	
XSendCAN
	GOSUB	XCANErr		On key detected, signal the abort
	GOSUB	InterrE		C[A]: interrupted error message number
	GOTO	XSendExitC
*
*  Now send the EOT/CAN.  Retransmit if necessary.
*
XSend90	C=R2
	C=C-1	XS		Retried out?
	GOC	XSendExit	Yes, quit
XSend95	R2=C
	C=D	A
	GOSUB	SendByteTIO
	?ST=1	sOnKeyDown
	GOYES	XSendExit
	GOSUB	RecByte15	15 second wait
	GOC	XSend90		Timeout, retransmit
	LC(2)	CAN
	?A=C	B		CAN?
	GOYES	XSendExit	Yes, exit
	LC(2)	ACK
	?A#C	B		NAK or garbage byte?
	GOYES	XSend90		Yes, retransmit
	?ST=1	sOnKeyDown
	GOYES	XSendExit
	ST=0	sError
XSendExit	
XSendExitC
	GOSUB	OkRAM		Reconfigure the RAM if needed
	GOSUB	Reconfig	Put back the other modules
	GOSBVL	=AllowIntr
	GOSBVL	=GETPTR
	GOTO	PushT/FLp

XSend80
	?ST=0	s1stpart	Already send the 2nd part ?
	GOYES	continue
	GOTO	XSend81		Yes, end the transfer
continue
	
*
* Uncover the ROM by moving the RAM at #00000
*		
	A=PC
	LC(5)	(Return1)-(*)
	A=A+C	A
	LC(5)	#70000		On Charles
	?ST=0	sAlcuin
	GOYES	Charles3
	LC(5)	#80000		On Alcuin
Charles3
	D=C	A
	C=A-C	A
	RSTK=C			Put @ return in the stack
	LC(5)	#5F44D
	RSTK=C			CONFIG RTN
	LC(5)	#5E1D1
	RSTK=C			C=A.A RTN
	LC(5)	=TIMER2
	RSTK=C			C=B.A CONFIG RTN

	C=D	A		C=@RAM
	D0=C
	D0=D0+	5		D0=(5)IRAMMASK
	A=DAT0	A
	B=A	A		B=IRAMMASK
	GOSUB	InitClock
	C=D	A		C=@RAM
	A=0	A		A=@New Ram
	GOVLNG	#4CFD0		UNCNFG RTN
Return1
	GOSUB	RecallClock
	D0=(5)	(=DISP1CTL)+4	Change the Screen address
	C=0	A		For the new RAM location
	DAT0=C	1
	D0=(5)	(=DISP2CTL)+4	Change the menu address
	DAT0=C	1

	LCHEX	10308		C=IN RTN
	D0=(5)	#00000		So we can still check if ON is pressed
	DAT0=C	A

	LC(5)	#10000		32kB left for Charles
	?ST=0	sAlcuin
	GOYES	Charles4
	LC(5)	#80000		256kB left for Alcuin
Charles4
	CSRB.F	A		C[A]: size of object in bytes
	R1=C			R1[A]: size of object in bytes
	LCHEX	901		
	R2=C			R2[B]: expected pkt #, R2[XS]: retry counter
	ST=1	s1stpart	Not to enter here the next time
	GOTO	XSend20
	
XSend81
	LC(2)	EOT		It's finished!!.
	D=C	A
	LCHEX	500
	GOTO	XSend95

XCANErr	LCHEX	218		C[XS]: byte count, C[B]: CAN byte
XCAN2	GOSUB	SendByte	Send 3 CAN bytes
	C=C-1	XS
	GONC	XCAN2
	RTN

InitClock
	D0=(5)  =TIMER2         Save the value of the clock
	C=DAT0  8
	R4=C
LoopClock
	A=DAT0	B
	?A=C	P
	GOYES	LoopClock
	LCHEX   105089D         C=B.A CONFIG RTN 
	DAT0=C  7		We write the sub-program in the Clock
	RTN			The value in the clock won't change for the
				next 480 cycles on the GX (approx. 300 on SX)
	
RecallClock
	D0=(5)	=TIMER2		Restore the previous value of the clock
	C=R4
	DAT0=C	8
	RTN
	
*
* Checks if ON is pressed. Carry=YES
*
OnKeyDown?2
	?ST=1	s1stpart
	GOYES	InRam
	GOVLNG	=OnKeyDown?
InRam
	GOSBVL	#00000		C=IN
	?CBIT=1	15
	RTNYES
	RTN	
*
* Reconfigure the RAM in #F0000
*
OkRAM
*
* Reconfigure the RAM in the Right place
*
	?ST=0	s1stpart	RAM in #E0000 ?
	RTNYES			No? exit
	ST=0	s1stpart

	D0=(5)	#00000
	LCHEX	A5C3F		KeyWord at the beginning of the RAM
	DAT0=C	A

	D0=(5)	(=DISP1CTL)+4	Put the screen back
	LCHEX	7
	?ST=0	sAlcuin
	GOYES	Charles6
	LCHEX	8
Charles6
	DAT0=C	1
	D0=(2)	(=DISP2CTL)+4	Put the menu back
	DAT0=C	1

	A=PC			Put the new address of PC
	LC(5)	(Return2)-(*)
	A=A+C	A
	LC(5)	#70000		On Charles
	?ST=0	sAlcuin
	GOYES	Charles7
	LC(5)	#80000		On Alcuin
Charles7
	D=C	A
	C=C+A	A
	RSTK=C			Put @ return in the stack
	LC(5)	#5F44D
	RSTK=C			CONFIG RTN
	LC(5)	#5E1D1
	RSTK=C			C=A.A RTN
	LC(5)	=TIMER2
	RSTK=C			C=B.A CONFIG RTN
	D0=(5)	#00005		D0=(5)IRAMMASK
	C=DAT0	A
	B=C	A		B=IRAMMASK
	GOSUB	InitClock
	C=D	A
	A=C	A
	C=0	A		C=@RAM
	GOVLNG	#4CFD0		UNCNFG RTN
	
Return2
	GOSUB	RecallClock
	?ST=0	sAlcuin
	GOYES	Charles8
Charles8
	C=RSTK
	A=C	A
	C=D	A
	C=C+A	A
	PC=C			Return to the caller

*
* Put back, BANK and BankSwitcher
*
Reconfig
	?ST=0	sAlcuin		Not needed on Charlemagne
	RTNYES
	LC(5)	#FF000		BankSwitcher
	CONFIG
	LC(5)	#7F000		At the address 7F000
	CONFIG

	D0=(5)	#80535		D0=(5)(=CONFTAB)+#10
	A=DAT0	1
	?A=0	P		ROM Already uncovered (true for the HP48G only)
	GOYES	Charles5
	D0=(5)	#8069A		D0=(5)LINECOUNTg
	A=DAT0	B
	ABIT=0	6
	D0=(5)	LINECOUNT	DA19=0, disable ROM
	DAT0=A	B
	D0=(5)	#7F040		Enable Bank Switcher
	A=DAT0	B
Charles5
	D0=(5)	#8052F		D0=(5)(=CONFTAB)+#4 (port1 present)
	A=DAT0	B
	?A#0	P
	GOYES	CardInSlot1.bis
	LC(5)	#FF000		Dock1 (e.g Port1)
	CONFIG
	LC(5)	#7E000
	GONC	Card1Next.bis	B.E.T
CardInSlot1.bis
	ASR	A		D0=(5)(=CONFTAB+#5)
	LCHEX	2		Check the size of the card
	?A=C	P
	GOYES	Port1=128K
	LC(5)	#F0000		Mask32K
	GONC	Port1Next.ter	B.E.T
Port1=128K
	LC(5)	#C0000		Mask128K
Port1Next.ter
	CONFIG
	LC(5)	#C0000

Card1Next.bis
	CONFIG
	D0=(5)	#80531		D0=(5)(=CONFTAB)+#6
	A=DAT0	B
	?A#0	P
	GOYES	CardInSlot2.bis
	LC(5)	#FF000
	CONFIG
	LC(5)	#7E000
	GONC	Port2Next.bis	B.E.T
CardInSlot2.bis
	LC(5)	#C0000		Mask182K
	CONFIG
Port2Next.bis
	CONFIG
	RTN


*********************************************************
* RecByte
*
* In:	C[A]: number of 8192 Hz ticks to wait before timing out
*	Hexmode, P=0
* Out:	Hexmode, P=0
*	If timed out: CS, C[A]: Timeout error message number
*	If ON key down:  sets sOnKeyDown = 1
*	If got a byte: CC, A[B] = byte
*	  sPktError = 1 if framing or uart overrun error occurred
* Uses:	A[A], C[A], D1, ST[sPktError], carry,   +0 sub levels
*********************************************************
RecByte1
	LC(5)	8192		1 second timeout
RecByte D1=(5)  =TIMER2 
	A=DAT1  A
	A=A-C	A		A[A]: Timer2 target
RecB10	D1=(2)	=RCS                   3   2   1   0  
	C=DAT1	1		C[0]: [RX RER RBZ RBF]
	?CBIT=1	0		Receive Buffer Full?
	GOYES	RecB40		Yes
	GOSUB	OnKeyDown?2
	GONC	RecB20		ON key not down
	ST=1	sOnKeyDown	Abort for ON key down
	LC(5)	8192/4		0.25 second max wait
	GOC	RecByte		BET

RecB20	D1=(2)  =TIMER2 
        C=DAT1  A       
        ?A#C    A       	TimeOut?              
        GOYES   RecB10		No, keep waiting
	LC(5)	#C02		"Timeout" error message number
	?ST=0	sOnKeyDown
	RTNYES			Return with carry set
InterrE	LCHEX	00A03		Interrupted
	RTNSC			Yes, return with carry set

RecB40	?CBIT=0	2		Overrun or framing error?
	GOYES	RecB50		No
	ST=1	sPktError	Yes, remember the errors
	D1=(2)	=CRER
	DAT1=A	1		RER cleared by writing anything
RecB50	D1=(2)	=RBR
	A=0	A
	A=DAT1	B
	RTNCC

RecByte15
	LC(5)	8192*5		5 second wait (was 15)
	GOTO	RecByte


*********************************************************
* SendPktHdr		Send packet header
*
* In:	R2[B]: packet number
*	P=0, hexmode
* Out:	R2[B]: packet number
*	P=0, hexmode
*	If timed out waiting for TBR=0: !! jumps to SendTOut
* Uses:	A[A], C, D1,	carry	+1 sub level
*********************************************************
SendPktHdr
	LC(2)	01
	GOSUB	SendByte	Send SOH
	C=R2
	GOSUB	SendByte	Send packet number
	C=-C-1	A		Send one's complement packet number
*			!!! falls into SendByte!
***************************************************
* SendByte
*
* Don't look for ON key here.  Would still have to send the rest of 
* the packet and wait for an ACK/NAK before sending CAN
*
* In:	C[B]: byte to send
*	P=0, hexmode
* Out:	P=0, hexmode
*	If timed out waiting for TBR=0: !! jumps to XSendExit or XRecAbort
* Uses:	A[A], D1, ST[sOnKeyDown], carry, +2 sub levels
*********************************************************
SendByte
	RSTK=C		
	LC(5)	40000		(91 cyc/loop)(250 ns/cyc)
	A=C	A		~0.9 second timeout 
	D1=(5)	=TCS						 
SendB1	C=DAT1  1		A[0]: TCS= [BRK LPB TBZ TBF]	18
        ?CBIT=0 0		Transmit Buffer empty?		 9
	GOYES	SendB4		Yes, send byte
	GOSUB	OnKeyDown?2					40
	GONC	SendB2		ON key not down		      10/3
	ST=1	sOnKeyDown	Abort for ON key down		 4
SendB2	A=A-1	A		Timeout?			 7
	GONC	SendB1		No, keep waiting		10
	C=RSTK
XSExj2	GOTO	XSendExit

SendB4	D1=(2)	=TBR
	C=RSTK
	DAT1=C	B		Send the byte
	RTN

*********************************************************
* SendByteTIO		Send a byte and toggle the IO annunciator
*
* In:	C[B]: byte to send
*	P=0, hexmode
* Out:	P=0, hexmode
*	If timed out waiting for TBR=0: !! jumps to SendTOut
* Uses:	A[A], C[A], D1,	carry	+2 sub levels
*********************************************************
SendByteTIO
	GOSUB	SendByte
*
* Toggle the I/O annunciator and clear IR reflections
* 
* In:	nothing
* Out:	D1 -> IO annunciator nibble
* Uses:	A[A], C[A], D1, carry
*
	D1=(5)  (=ANNCTRL)+1                 
	C=DAT1  1       	C[0]:[AON XTRA IO A5]
	A=C	A
	CBIT=0  1       	C[0]:[AON XTRA  0 A5]
	?ABIT=1	1		IO annunciator ON?
	GOYES	TogIO20		Yes, turn it off
	CBIT=1	1		C[0]:[AON XTRA  1 A5]
TogIO20	DAT1=C  1		Toggle IO Annunciator
        RTN	 		done

	
PushT/FLp
	?ST=1	sError
	GOYES	Exit
	GOVLNG	=PushTLoop
Exit	GOVLNG	=PushFLoop

EndOfCode
	
ENDCODE			( T | F )
  CLOSEUART
  ITE
	$ "Upload succeeded"
	$ "Upload Failed"
  ;
